<?php

class FszNotenVerwaltungConfig{
	var $seminar_id;
	var $data = array();
	var $marks = array();
	var $conf = array('NOTIFY_USER' => 0, 'VISIBLE' => 0);
	
	function FszNotenVerwaltungConfig($seminar_id){
		$this->seminar_id = $seminar_id;
		$this->restore();
	}
	
	function getNewId(){
		return md5(uniqid('FszNotenVerwaltung',1));
	}
	
	function restore(){
		$db = new DB_Seminar();
		$this->data = array();
		$this->marks = array();
		$this->conf = array();
		$db->queryf("SELECT * FROM fsz_notenverwaltung_config WHERE seminar_id='%s' ORDER BY name", $this->seminar_id);
		while($db->next_record()){
			$this->data[$db->f('id')] = $db->Record;
		}
		foreach($this->data as $id => $data){
			list($name, $bezug) = explode('-', $data['name']);
			if($name == 'MARK'){
				$this->marks[$id]['desc'] = $data['value'];
			} elseif($name == 'WEIGHT'){
				$this->marks[$bezug]['weight'] = $data['value'];
			} else {
				$this->conf[$name] = $data['value'];
			}
		}
	}
	
	function store(){
		$db = new DB_Seminar();
		foreach($this->marks as $id => $data){
			$this->data[$id]['id'] = $id;
			$this->data[$id]['seminar_id'] = $this->seminar_id;
			$this->data[$id]['name'] = 'MARK';
			$this->data[$id]['value'] = $data['desc'];
			$wid = md5('WEIGHT-' . $id);
			$this->data[$wid]['id'] = $wid;
			$this->data[$wid]['seminar_id'] = $this->seminar_id;
			$this->data[$wid]['name'] = 'WEIGHT-' . $id;
			$this->data[$wid]['value'] = $data['weight'];
		}
		foreach($this->conf as $name => $value){
			$id = md5($name);
			$this->data[$id]['id'] = $id;
			$this->data[$id]['seminar_id'] = $this->seminar_id;
			$this->data[$id]['name'] = $name;
			$this->data[$id]['value'] = $value;
		}
		foreach($this->data as $row){
			$ret += $db->queryf("REPLACE INTO fsz_notenverwaltung_config (id,seminar_id,name,value) VALUES ('%s','%s','%s','%s')",
						$row['id'],
						$row['seminar_id'],
						$row['name'],
						$row['value']);
		}
		$this->restore();
		return $ret;
	}
	
	function deleteMark($mark_id){
		if(isset($this->marks[$mark_id])){
			$db = new DB_Seminar();
			$db->queryf("DELETE FROM fsz_notenverwaltung_noten WHERE config_id = '%s'", $mark_id);
			$ret = $db->queryf("DELETE FROM fsz_notenverwaltung_config WHERE id IN ('%s','%s')", $mark_id, md5('WEIGHT-' . $mark_id));
			$this->restore();
		}
		return $ret;
	}
}
?>
